# Copyright 2019 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

# This file is automatically generated by mkgrokdump and should not
# be modified manually.

# List of known V8 instance types.
INSTANCE_TYPES = {
  0: "INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  8: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  18: "UNCACHED_EXTERNAL_INTERNALIZED_STRING_TYPE",
  26: "UNCACHED_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  32: "STRING_TYPE",
  33: "CONS_STRING_TYPE",
  34: "EXTERNAL_STRING_TYPE",
  35: "SLICED_STRING_TYPE",
  37: "THIN_STRING_TYPE",
  40: "ONE_BYTE_STRING_TYPE",
  41: "CONS_ONE_BYTE_STRING_TYPE",
  42: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  43: "SLICED_ONE_BYTE_STRING_TYPE",
  45: "THIN_ONE_BYTE_STRING_TYPE",
  50: "UNCACHED_EXTERNAL_STRING_TYPE",
  58: "UNCACHED_EXTERNAL_ONE_BYTE_STRING_TYPE",
  64: "SYMBOL_TYPE",
  65: "HEAP_NUMBER_TYPE",
  66: "BIGINT_TYPE",
  67: "ODDBALL_TYPE",
  68: "MAP_TYPE",
  69: "CODE_TYPE",
  70: "FOREIGN_TYPE",
  71: "BYTE_ARRAY_TYPE",
  72: "BYTECODE_ARRAY_TYPE",
  73: "FREE_SPACE_TYPE",
  74: "FIXED_DOUBLE_ARRAY_TYPE",
  75: "FEEDBACK_METADATA_TYPE",
  76: "FILLER_TYPE",
  77: "ACCESS_CHECK_INFO_TYPE",
  78: "ACCESSOR_INFO_TYPE",
  79: "ACCESSOR_PAIR_TYPE",
  80: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  81: "ALLOCATION_MEMENTO_TYPE",
  82: "ARRAY_BOILERPLATE_DESCRIPTION_TYPE",
  83: "ASM_WASM_DATA_TYPE",
  84: "ASYNC_GENERATOR_REQUEST_TYPE",
  85: "CLASS_POSITIONS_TYPE",
  86: "DEBUG_INFO_TYPE",
  87: "ENUM_CACHE_TYPE",
  88: "FUNCTION_TEMPLATE_INFO_TYPE",
  89: "FUNCTION_TEMPLATE_RARE_DATA_TYPE",
  90: "INTERCEPTOR_INFO_TYPE",
  91: "INTERPRETER_DATA_TYPE",
  92: "OBJECT_TEMPLATE_INFO_TYPE",
  93: "PROMISE_CAPABILITY_TYPE",
  94: "PROMISE_REACTION_TYPE",
  95: "PROTOTYPE_INFO_TYPE",
  96: "SCRIPT_TYPE",
  97: "SOURCE_POSITION_TABLE_WITH_FRAME_CACHE_TYPE",
  98: "SOURCE_TEXT_MODULE_INFO_ENTRY_TYPE",
  99: "STACK_FRAME_INFO_TYPE",
  100: "STACK_TRACE_FRAME_TYPE",
  101: "TEMPLATE_OBJECT_DESCRIPTION_TYPE",
  102: "TUPLE2_TYPE",
  103: "TUPLE3_TYPE",
  104: "WASM_CAPI_FUNCTION_DATA_TYPE",
  105: "WASM_DEBUG_INFO_TYPE",
  106: "WASM_EXCEPTION_TAG_TYPE",
  107: "WASM_EXPORTED_FUNCTION_DATA_TYPE",
  108: "WASM_INDIRECT_FUNCTION_TABLE_TYPE",
  109: "WASM_JS_FUNCTION_DATA_TYPE",
  110: "CALLABLE_TASK_TYPE",
  111: "CALLBACK_TASK_TYPE",
  112: "PROMISE_FULFILL_REACTION_JOB_TASK_TYPE",
  113: "PROMISE_REJECT_REACTION_JOB_TASK_TYPE",
  114: "PROMISE_RESOLVE_THENABLE_JOB_TASK_TYPE",
  115: "INTERNAL_CLASS_TYPE",
  116: "SMI_PAIR_TYPE",
  117: "SMI_BOX_TYPE",
  118: "SORT_STATE_TYPE",
  119: "SOURCE_TEXT_MODULE_TYPE",
  120: "SYNTHETIC_MODULE_TYPE",
  121: "ALLOCATION_SITE_TYPE",
  122: "EMBEDDER_DATA_ARRAY_TYPE",
  123: "FIXED_ARRAY_TYPE",
  124: "OBJECT_BOILERPLATE_DESCRIPTION_TYPE",
  125: "CLOSURE_FEEDBACK_CELL_ARRAY_TYPE",
  126: "HASH_TABLE_TYPE",
  127: "ORDERED_HASH_MAP_TYPE",
  128: "ORDERED_HASH_SET_TYPE",
  129: "ORDERED_NAME_DICTIONARY_TYPE",
  130: "NAME_DICTIONARY_TYPE",
  131: "GLOBAL_DICTIONARY_TYPE",
  132: "NUMBER_DICTIONARY_TYPE",
  133: "SIMPLE_NUMBER_DICTIONARY_TYPE",
  134: "STRING_TABLE_TYPE",
  135: "EPHEMERON_HASH_TABLE_TYPE",
  136: "SCOPE_INFO_TYPE",
  137: "SCRIPT_CONTEXT_TABLE_TYPE",
  138: "AWAIT_CONTEXT_TYPE",
  139: "BLOCK_CONTEXT_TYPE",
  140: "CATCH_CONTEXT_TYPE",
  141: "DEBUG_EVALUATE_CONTEXT_TYPE",
  142: "EVAL_CONTEXT_TYPE",
  143: "FUNCTION_CONTEXT_TYPE",
  144: "MODULE_CONTEXT_TYPE",
  145: "NATIVE_CONTEXT_TYPE",
  146: "SCRIPT_CONTEXT_TYPE",
  147: "WITH_CONTEXT_TYPE",
  148: "WEAK_FIXED_ARRAY_TYPE",
  149: "TRANSITION_ARRAY_TYPE",
  150: "CALL_HANDLER_INFO_TYPE",
  151: "CELL_TYPE",
  152: "CODE_DATA_CONTAINER_TYPE",
  153: "DESCRIPTOR_ARRAY_TYPE",
  154: "FEEDBACK_CELL_TYPE",
  155: "FEEDBACK_VECTOR_TYPE",
  156: "LOAD_HANDLER_TYPE",
  157: "PREPARSE_DATA_TYPE",
  158: "PROPERTY_ARRAY_TYPE",
  159: "PROPERTY_CELL_TYPE",
  160: "SHARED_FUNCTION_INFO_TYPE",
  161: "SMALL_ORDERED_HASH_MAP_TYPE",
  162: "SMALL_ORDERED_HASH_SET_TYPE",
  163: "SMALL_ORDERED_NAME_DICTIONARY_TYPE",
  164: "STORE_HANDLER_TYPE",
  165: "UNCOMPILED_DATA_WITHOUT_PREPARSE_DATA_TYPE",
  166: "UNCOMPILED_DATA_WITH_PREPARSE_DATA_TYPE",
  167: "WEAK_ARRAY_LIST_TYPE",
  168: "WEAK_CELL_TYPE",
  1024: "JS_PROXY_TYPE",
  1025: "JS_GLOBAL_OBJECT_TYPE",
  1026: "JS_GLOBAL_PROXY_TYPE",
  1027: "JS_MODULE_NAMESPACE_TYPE",
  1040: "JS_SPECIAL_API_OBJECT_TYPE",
  1041: "JS_PRIMITIVE_WRAPPER_TYPE",
  1056: "JS_API_OBJECT_TYPE",
  1057: "JS_OBJECT_TYPE",
  1058: "JS_ARGUMENTS_TYPE",
  1059: "JS_ARRAY_BUFFER_TYPE",
  1060: "JS_ARRAY_ITERATOR_TYPE",
  1061: "JS_ARRAY_TYPE",
  1062: "JS_ASYNC_FROM_SYNC_ITERATOR_TYPE",
  1063: "JS_ASYNC_FUNCTION_OBJECT_TYPE",
  1064: "JS_ASYNC_GENERATOR_OBJECT_TYPE",
  1065: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  1066: "JS_DATE_TYPE",
  1067: "JS_ERROR_TYPE",
  1068: "JS_GENERATOR_OBJECT_TYPE",
  1069: "JS_MAP_TYPE",
  1070: "JS_MAP_KEY_ITERATOR_TYPE",
  1071: "JS_MAP_KEY_VALUE_ITERATOR_TYPE",
  1072: "JS_MAP_VALUE_ITERATOR_TYPE",
  1073: "JS_MESSAGE_OBJECT_TYPE",
  1074: "JS_PROMISE_TYPE",
  1075: "JS_REGEXP_TYPE",
  1076: "JS_REGEXP_STRING_ITERATOR_TYPE",
  1077: "JS_SET_TYPE",
  1078: "JS_SET_KEY_VALUE_ITERATOR_TYPE",
  1079: "JS_SET_VALUE_ITERATOR_TYPE",
  1080: "JS_STRING_ITERATOR_TYPE",
  1081: "JS_WEAK_REF_TYPE",
  1082: "JS_FINALIZATION_GROUP_CLEANUP_ITERATOR_TYPE",
  1083: "JS_FINALIZATION_GROUP_TYPE",
  1084: "JS_WEAK_MAP_TYPE",
  1085: "JS_WEAK_SET_TYPE",
  1086: "JS_TYPED_ARRAY_TYPE",
  1087: "JS_DATA_VIEW_TYPE",
  1088: "JS_INTL_V8_BREAK_ITERATOR_TYPE",
  1089: "JS_INTL_COLLATOR_TYPE",
  1090: "JS_INTL_DATE_TIME_FORMAT_TYPE",
  1091: "JS_INTL_LIST_FORMAT_TYPE",
  1092: "JS_INTL_LOCALE_TYPE",
  1093: "JS_INTL_NUMBER_FORMAT_TYPE",
  1094: "JS_INTL_PLURAL_RULES_TYPE",
  1095: "JS_INTL_RELATIVE_TIME_FORMAT_TYPE",
  1096: "JS_INTL_SEGMENT_ITERATOR_TYPE",
  1097: "JS_INTL_SEGMENTER_TYPE",
  1098: "WASM_EXCEPTION_TYPE",
  1099: "WASM_GLOBAL_TYPE",
  1100: "WASM_INSTANCE_TYPE",
  1101: "WASM_MEMORY_TYPE",
  1102: "WASM_MODULE_TYPE",
  1103: "WASM_TABLE_TYPE",
  1104: "JS_BOUND_FUNCTION_TYPE",
  1105: "JS_FUNCTION_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
  ("read_only_space", 0x00121): (73, "FreeSpaceMap"),
  ("read_only_space", 0x00171): (68, "MetaMap"),
  ("read_only_space", 0x001f1): (67, "NullMap"),
  ("read_only_space", 0x00259): (153, "DescriptorArrayMap"),
  ("read_only_space", 0x002b9): (148, "WeakFixedArrayMap"),
  ("read_only_space", 0x00309): (76, "OnePointerFillerMap"),
  ("read_only_space", 0x00359): (76, "TwoPointerFillerMap"),
  ("read_only_space", 0x003d9): (67, "UninitializedMap"),
  ("read_only_space", 0x00449): (8, "OneByteInternalizedStringMap"),
  ("read_only_space", 0x004e9): (67, "UndefinedMap"),
  ("read_only_space", 0x00549): (65, "HeapNumberMap"),
  ("read_only_space", 0x005c9): (67, "TheHoleMap"),
  ("read_only_space", 0x00671): (67, "BooleanMap"),
  ("read_only_space", 0x00749): (71, "ByteArrayMap"),
  ("read_only_space", 0x00799): (123, "FixedArrayMap"),
  ("read_only_space", 0x007e9): (123, "FixedCOWArrayMap"),
  ("read_only_space", 0x00839): (126, "HashTableMap"),
  ("read_only_space", 0x00889): (64, "SymbolMap"),
  ("read_only_space", 0x008d9): (40, "OneByteStringMap"),
  ("read_only_space", 0x00929): (136, "ScopeInfoMap"),
  ("read_only_space", 0x00979): (160, "SharedFunctionInfoMap"),
  ("read_only_space", 0x009c9): (69, "CodeMap"),
  ("read_only_space", 0x00a19): (143, "FunctionContextMap"),
  ("read_only_space", 0x00a69): (151, "CellMap"),
  ("read_only_space", 0x00ab9): (159, "GlobalPropertyCellMap"),
  ("read_only_space", 0x00b09): (70, "ForeignMap"),
  ("read_only_space", 0x00b59): (149, "TransitionArrayMap"),
  ("read_only_space", 0x00ba9): (155, "FeedbackVectorMap"),
  ("read_only_space", 0x00c49): (67, "ArgumentsMarkerMap"),
  ("read_only_space", 0x00ce9): (67, "ExceptionMap"),
  ("read_only_space", 0x00d89): (67, "TerminationExceptionMap"),
  ("read_only_space", 0x00e31): (67, "OptimizedOutMap"),
  ("read_only_space", 0x00ed1): (67, "StaleRegisterMap"),
  ("read_only_space", 0x00f41): (145, "NativeContextMap"),
  ("read_only_space", 0x00f91): (144, "ModuleContextMap"),
  ("read_only_space", 0x00fe1): (142, "EvalContextMap"),
  ("read_only_space", 0x01031): (146, "ScriptContextMap"),
  ("read_only_space", 0x01081): (138, "AwaitContextMap"),
  ("read_only_space", 0x010d1): (139, "BlockContextMap"),
  ("read_only_space", 0x01121): (140, "CatchContextMap"),
  ("read_only_space", 0x01171): (147, "WithContextMap"),
  ("read_only_space", 0x011c1): (141, "DebugEvaluateContextMap"),
  ("read_only_space", 0x01211): (137, "ScriptContextTableMap"),
  ("read_only_space", 0x01261): (125, "ClosureFeedbackCellArrayMap"),
  ("read_only_space", 0x012b1): (75, "FeedbackMetadataArrayMap"),
  ("read_only_space", 0x01301): (123, "ArrayListMap"),
  ("read_only_space", 0x01351): (66, "BigIntMap"),
  ("read_only_space", 0x013a1): (124, "ObjectBoilerplateDescriptionMap"),
  ("read_only_space", 0x013f1): (72, "BytecodeArrayMap"),
  ("read_only_space", 0x01441): (152, "CodeDataContainerMap"),
  ("read_only_space", 0x01491): (74, "FixedDoubleArrayMap"),
  ("read_only_space", 0x014e1): (131, "GlobalDictionaryMap"),
  ("read_only_space", 0x01531): (154, "ManyClosuresCellMap"),
  ("read_only_space", 0x01581): (123, "ModuleInfoMap"),
  ("read_only_space", 0x015d1): (130, "NameDictionaryMap"),
  ("read_only_space", 0x01621): (154, "NoClosuresCellMap"),
  ("read_only_space", 0x01671): (132, "NumberDictionaryMap"),
  ("read_only_space", 0x016c1): (154, "OneClosureCellMap"),
  ("read_only_space", 0x01711): (127, "OrderedHashMapMap"),
  ("read_only_space", 0x01761): (128, "OrderedHashSetMap"),
  ("read_only_space", 0x017b1): (129, "OrderedNameDictionaryMap"),
  ("read_only_space", 0x01801): (157, "PreparseDataMap"),
  ("read_only_space", 0x01851): (158, "PropertyArrayMap"),
  ("read_only_space", 0x018a1): (150, "SideEffectCallHandlerInfoMap"),
  ("read_only_space", 0x018f1): (150, "SideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x01941): (150, "NextCallSideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x01991): (133, "SimpleNumberDictionaryMap"),
  ("read_only_space", 0x019e1): (123, "SloppyArgumentsElementsMap"),
  ("read_only_space", 0x01a31): (161, "SmallOrderedHashMapMap"),
  ("read_only_space", 0x01a81): (162, "SmallOrderedHashSetMap"),
  ("read_only_space", 0x01ad1): (163, "SmallOrderedNameDictionaryMap"),
  ("read_only_space", 0x01b21): (119, "SourceTextModuleMap"),
  ("read_only_space", 0x01b71): (134, "StringTableMap"),
  ("read_only_space", 0x01bc1): (120, "SyntheticModuleMap"),
  ("read_only_space", 0x01c11): (165, "UncompiledDataWithoutPreparseDataMap"),
  ("read_only_space", 0x01c61): (166, "UncompiledDataWithPreparseDataMap"),
  ("read_only_space", 0x01cb1): (167, "WeakArrayListMap"),
  ("read_only_space", 0x01d01): (135, "EphemeronHashTableMap"),
  ("read_only_space", 0x01d51): (122, "EmbedderDataArrayMap"),
  ("read_only_space", 0x01da1): (168, "WeakCellMap"),
  ("read_only_space", 0x01df1): (58, "NativeSourceStringMap"),
  ("read_only_space", 0x01e41): (32, "StringMap"),
  ("read_only_space", 0x01e91): (41, "ConsOneByteStringMap"),
  ("read_only_space", 0x01ee1): (33, "ConsStringMap"),
  ("read_only_space", 0x01f31): (45, "ThinOneByteStringMap"),
  ("read_only_space", 0x01f81): (37, "ThinStringMap"),
  ("read_only_space", 0x01fd1): (35, "SlicedStringMap"),
  ("read_only_space", 0x02021): (43, "SlicedOneByteStringMap"),
  ("read_only_space", 0x02071): (34, "ExternalStringMap"),
  ("read_only_space", 0x020c1): (42, "ExternalOneByteStringMap"),
  ("read_only_space", 0x02111): (50, "UncachedExternalStringMap"),
  ("read_only_space", 0x02161): (0, "InternalizedStringMap"),
  ("read_only_space", 0x021b1): (2, "ExternalInternalizedStringMap"),
  ("read_only_space", 0x02201): (10, "ExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x02251): (18, "UncachedExternalInternalizedStringMap"),
  ("read_only_space", 0x022a1): (26, "UncachedExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x022f1): (58, "UncachedExternalOneByteStringMap"),
  ("read_only_space", 0x02341): (67, "SelfReferenceMarkerMap"),
  ("read_only_space", 0x023a9): (87, "EnumCacheMap"),
  ("read_only_space", 0x02449): (82, "ArrayBoilerplateDescriptionMap"),
  ("read_only_space", 0x02639): (90, "InterceptorInfoMap"),
  ("read_only_space", 0x04f91): (77, "AccessCheckInfoMap"),
  ("read_only_space", 0x04fe1): (78, "AccessorInfoMap"),
  ("read_only_space", 0x05031): (79, "AccessorPairMap"),
  ("read_only_space", 0x05081): (80, "AliasedArgumentsEntryMap"),
  ("read_only_space", 0x050d1): (81, "AllocationMementoMap"),
  ("read_only_space", 0x05121): (83, "AsmWasmDataMap"),
  ("read_only_space", 0x05171): (84, "AsyncGeneratorRequestMap"),
  ("read_only_space", 0x051c1): (85, "ClassPositionsMap"),
  ("read_only_space", 0x05211): (86, "DebugInfoMap"),
  ("read_only_space", 0x05261): (88, "FunctionTemplateInfoMap"),
  ("read_only_space", 0x052b1): (89, "FunctionTemplateRareDataMap"),
  ("read_only_space", 0x05301): (91, "InterpreterDataMap"),
  ("read_only_space", 0x05351): (92, "ObjectTemplateInfoMap"),
  ("read_only_space", 0x053a1): (93, "PromiseCapabilityMap"),
  ("read_only_space", 0x053f1): (94, "PromiseReactionMap"),
  ("read_only_space", 0x05441): (95, "PrototypeInfoMap"),
  ("read_only_space", 0x05491): (96, "ScriptMap"),
  ("read_only_space", 0x054e1): (97, "SourcePositionTableWithFrameCacheMap"),
  ("read_only_space", 0x05531): (98, "SourceTextModuleInfoEntryMap"),
  ("read_only_space", 0x05581): (99, "StackFrameInfoMap"),
  ("read_only_space", 0x055d1): (100, "StackTraceFrameMap"),
  ("read_only_space", 0x05621): (101, "TemplateObjectDescriptionMap"),
  ("read_only_space", 0x05671): (102, "Tuple2Map"),
  ("read_only_space", 0x056c1): (103, "Tuple3Map"),
  ("read_only_space", 0x05711): (104, "WasmCapiFunctionDataMap"),
  ("read_only_space", 0x05761): (105, "WasmDebugInfoMap"),
  ("read_only_space", 0x057b1): (106, "WasmExceptionTagMap"),
  ("read_only_space", 0x05801): (107, "WasmExportedFunctionDataMap"),
  ("read_only_space", 0x05851): (108, "WasmIndirectFunctionTableMap"),
  ("read_only_space", 0x058a1): (109, "WasmJSFunctionDataMap"),
  ("read_only_space", 0x058f1): (110, "CallableTaskMap"),
  ("read_only_space", 0x05941): (111, "CallbackTaskMap"),
  ("read_only_space", 0x05991): (112, "PromiseFulfillReactionJobTaskMap"),
  ("read_only_space", 0x059e1): (113, "PromiseRejectReactionJobTaskMap"),
  ("read_only_space", 0x05a31): (114, "PromiseResolveThenableJobTaskMap"),
  ("read_only_space", 0x05a81): (115, "InternalClassMap"),
  ("read_only_space", 0x05ad1): (116, "SmiPairMap"),
  ("read_only_space", 0x05b21): (117, "SmiBoxMap"),
  ("read_only_space", 0x05b71): (118, "SortStateMap"),
  ("read_only_space", 0x05bc1): (121, "AllocationSiteWithWeakNextMap"),
  ("read_only_space", 0x05c11): (121, "AllocationSiteWithoutWeakNextMap"),
  ("read_only_space", 0x05c61): (156, "LoadHandler1Map"),
  ("read_only_space", 0x05cb1): (156, "LoadHandler2Map"),
  ("read_only_space", 0x05d01): (156, "LoadHandler3Map"),
  ("read_only_space", 0x05d51): (164, "StoreHandler0Map"),
  ("read_only_space", 0x05da1): (164, "StoreHandler1Map"),
  ("read_only_space", 0x05df1): (164, "StoreHandler2Map"),
  ("read_only_space", 0x05e41): (164, "StoreHandler3Map"),
  ("map_space", 0x00121): (1057, "ExternalMap"),
  ("map_space", 0x00171): (1073, "JSMessageObjectMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("read_only_space", 0x001c1): "NullValue",
  ("read_only_space", 0x00241): "EmptyDescriptorArray",
  ("read_only_space", 0x002a9): "EmptyWeakFixedArray",
  ("read_only_space", 0x003a9): "UninitializedValue",
  ("read_only_space", 0x004b9): "UndefinedValue",
  ("read_only_space", 0x00539): "NanValue",
  ("read_only_space", 0x00599): "TheHoleValue",
  ("read_only_space", 0x00631): "HoleNanValue",
  ("read_only_space", 0x00641): "TrueValue",
  ("read_only_space", 0x006f1): "FalseValue",
  ("read_only_space", 0x00739): "empty_string",
  ("read_only_space", 0x00bf9): "EmptyScopeInfo",
  ("read_only_space", 0x00c09): "EmptyFixedArray",
  ("read_only_space", 0x00c19): "ArgumentsMarker",
  ("read_only_space", 0x00cb9): "Exception",
  ("read_only_space", 0x00d59): "TerminationException",
  ("read_only_space", 0x00e01): "OptimizedOut",
  ("read_only_space", 0x00ea1): "StaleRegister",
  ("read_only_space", 0x02391): "EmptyEnumCache",
  ("read_only_space", 0x023f9): "EmptyPropertyArray",
  ("read_only_space", 0x02409): "EmptyByteArray",
  ("read_only_space", 0x02419): "EmptyObjectBoilerplateDescription",
  ("read_only_space", 0x02431): "EmptyArrayBoilerplateDescription",
  ("read_only_space", 0x02499): "EmptyClosureFeedbackCellArray",
  ("read_only_space", 0x024a9): "EmptySloppyArgumentsElements",
  ("read_only_space", 0x024c9): "EmptySlowElementDictionary",
  ("read_only_space", 0x02511): "EmptyOrderedHashMap",
  ("read_only_space", 0x02539): "EmptyOrderedHashSet",
  ("read_only_space", 0x02561): "EmptyFeedbackMetadata",
  ("read_only_space", 0x02571): "EmptyPropertyCell",
  ("read_only_space", 0x02599): "EmptyPropertyDictionary",
  ("read_only_space", 0x025e9): "NoOpInterceptorInfo",
  ("read_only_space", 0x02689): "EmptyWeakArrayList",
  ("read_only_space", 0x026a1): "InfinityValue",
  ("read_only_space", 0x026b1): "MinusZeroValue",
  ("read_only_space", 0x026c1): "MinusInfinityValue",
  ("read_only_space", 0x026d1): "SelfReferenceMarker",
  ("read_only_space", 0x02729): "OffHeapTrampolineRelocationInfo",
  ("read_only_space", 0x02741): "TrampolineTrivialCodeDataContainer",
  ("read_only_space", 0x02759): "TrampolinePromiseRejectionCodeDataContainer",
  ("read_only_space", 0x02771): "GlobalThisBindingScopeInfo",
  ("read_only_space", 0x027d9): "EmptyFunctionScopeInfo",
  ("read_only_space", 0x02829): "HashSeed",
  ("old_space", 0x00121): "ArgumentsIteratorAccessor",
  ("old_space", 0x00191): "ArrayLengthAccessor",
  ("old_space", 0x00201): "BoundFunctionLengthAccessor",
  ("old_space", 0x00271): "BoundFunctionNameAccessor",
  ("old_space", 0x002e1): "ErrorStackAccessor",
  ("old_space", 0x00351): "FunctionArgumentsAccessor",
  ("old_space", 0x003c1): "FunctionCallerAccessor",
  ("old_space", 0x00431): "FunctionNameAccessor",
  ("old_space", 0x004a1): "FunctionLengthAccessor",
  ("old_space", 0x00511): "FunctionPrototypeAccessor",
  ("old_space", 0x00581): "RegExpResultIndicesAccessor",
  ("old_space", 0x005f1): "StringLengthAccessor",
  ("old_space", 0x00661): "InvalidPrototypeValidityCell",
  ("old_space", 0x00671): "EmptyScript",
  ("old_space", 0x006f1): "ManyClosuresCell",
  ("old_space", 0x00709): "ArrayConstructorProtector",
  ("old_space", 0x00731): "NoElementsProtector",
  ("old_space", 0x00759): "IsConcatSpreadableProtector",
  ("old_space", 0x00781): "ArraySpeciesProtector",
  ("old_space", 0x007a9): "TypedArraySpeciesProtector",
  ("old_space", 0x007d1): "PromiseSpeciesProtector",
  ("old_space", 0x007f9): "StringLengthProtector",
  ("old_space", 0x00821): "ArrayIteratorProtector",
  ("old_space", 0x00849): "ArrayBufferDetachingProtector",
  ("old_space", 0x00871): "PromiseHookProtector",
  ("old_space", 0x00899): "PromiseResolveProtector",
  ("old_space", 0x008c1): "MapIteratorProtector",
  ("old_space", 0x008e9): "PromiseThenProtector",
  ("old_space", 0x00911): "SetIteratorProtector",
  ("old_space", 0x00939): "StringIteratorProtector",
  ("old_space", 0x00961): "SingleCharacterStringCache",
  ("old_space", 0x01171): "StringSplitCache",
  ("old_space", 0x01981): "RegExpMultipleCache",
  ("old_space", 0x02191): "BuiltinsConstantsTable",
}

# List of known V8 Frame Markers.
FRAME_MARKERS = (
  "ENTRY",
  "CONSTRUCT_ENTRY",
  "EXIT",
  "OPTIMIZED",
  "WASM_COMPILED",
  "WASM_TO_JS",
  "JS_TO_WASM",
  "WASM_INTERPRETER_ENTRY",
  "C_WASM_ENTRY",
  "WASM_EXIT",
  "WASM_COMPILE_LAZY",
  "INTERPRETED",
  "STUB",
  "BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION_WITH_CATCH",
  "INTERNAL",
  "CONSTRUCT",
  "ARGUMENTS_ADAPTOR",
  "BUILTIN",
  "BUILTIN_EXIT",
  "NATIVE",
)

# This set of constants is generated from a shipping build.
